package massim.agent.jazzyk;

import java.util.LinkedList;

import org.w3c.dom.Element;

import jazzyk.JazzykEngine;

import massim.agent.framework.AbstractSyncAgent;

public class JazzykAgent extends AbstractSyncAgent {

	protected JazzykEngine engine;
	Boolean bSimFinished = false;
	String srcFile;
	
	protected JazzykAgent(String username, String password) {
		super(username, password);
	}
	
	public JazzykAgent(String username, String password, String sourceFile) {
		super(username, password);
		srcFile = sourceFile;
	}
	
	@Override
	public synchronized void processSimulationEnd(Element perception, long currenttime) {
		bSimFinished = true;
	}

	protected void runSyncAgent() {
		// we are in a separate thread
		
		//REGISTER INTO THE HEADQUARTERS STORE!
		MASSimAgents.getInstance().register(getUsername(), this);
		
		LinkedList<String> inFiles = new LinkedList<String>();
		inFiles.add(srcFile);

		engine = new JazzykEngine();
		
		engine.load("define(`MYNAME', `\"" + getUsername() + "\"') \n").load(inFiles);
		engine.compile();

		Boolean bSimEnd = false;
	
		while (!bSimEnd) {
			engine.step();
			Thread.yield();
			synchronized(this) { bSimEnd = this.bSimFinished; }
		}
	}

	/**
	 * Launches the agent deliberation thread
	 */
	@Override
	public void run() {
		// launch the agent thread
		new Thread(
                new Runnable() {
                        public void run() {
                        	runSyncAgent();
                        }
                }
        ).start();

		// you can configure the agent's connection point
		run("localhost", 12300);
	}
}

